package com.winhc.bigdata.flink.java.entity;

import cn.hutool.core.lang.Tuple;
import com.alibaba.fastjson.JSONObject;
import com.winhc.bigdata.flink.utils.PreUDF;
import com.winhc.bigdata.flink.utils.RowDataUtils;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.var;

import java.util.List;
import java.util.Map;
import java.util.Optional;
import java.util.stream.Collectors;

/**
 * @author ZhangJi
 * @since 2021-10-22 11:09
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
public class RowBaseDimEntity implements DimEntity {
    private MetaInfo metaInfo;
    private Map<String, JSONObject> data;
    private Map<String, JSONObject> old;

    @Override
    public String companyId() {
        return Optional.ofNullable(metaInfo).map(MetaInfo::getCompany).map(MetaInfo.CompanyInfo::getCompanyId).orElse(null);
    }

    public static RowBaseDimEntity of(Tuple dataT, Tuple metaT) {
        String dim = dataT.get(0);
        List<JSONObject> js = dataT.get(1);
        var data = js.stream()
                .map(j -> new Tuple(RowDataUtils.generateRowKey(dim, j), j))
                .filter(t -> t.get(0) != null)
                .collect(Collectors.toMap(t -> (String) t.get(0), t -> (JSONObject) t.get(1), (n, o) -> n));
        var meta = RowDataUtils.generateMetaInfoJava(dim, metaT.get(0), metaT.get(1));
        return new RowBaseDimEntity(meta, data, null);
    }
}

